Main Page | Namespace List | Class Hierarchy | Alphabetical List | Class List | File List | Namespace Members | Class Members | File Members

# PanamaMAC< B > Class Template Reference

`#include <panama.h>`

Inheritance diagram for PanamaMAC< B >:

List of all members.

## Detailed Description

### template<class B = LittleEndian>
class PanamaMAC< B >

Panama MAC.

Definition at line 99 of file panama.h.

## Public Types
enum | IV_Requirement { STRUCTURED_IV = 0, RANDOM_IV, UNPREDICTABLE_RANDOM_IV, INTERNALLY_GENERATED_IV, NOT_RESYNCHRONIZABLE }
## Public Member Functions
| PanamaMAC ()
| PanamaMAC (const byte *key, unsigned int length)
void | SetKey (const byte *key, unsigned int length, const NameValuePairs &params=g_nullNameValuePairs)
| set or reset the key of this object
void | Restart ()
| discard the current state, and restart with a new message
void | Update (const byte *input, unsigned int length)
| process more input
void | TruncatedFinal (byte *digest, unsigned int digestSize)
| truncated version of Final()
unsigned int | DigestSize () const
| size of the hash returned by Final()
unsigned int | BlockSize () const
| block size of underlying compression function, or 0 if not block based
unsigned int | OptimalBlockSize () const
| input to Update() should have length a multiple of this for optimal speed
unsigned int | OptimalDataAlignment () const
| returns how input should be aligned for optimal performance
std::string | AlgorithmName () const
| returns name of this algorithm, not universally implemented yet
unsigned int | MinKeyLength () const
| returns smallest valid key length in bytes */
unsigned int | MaxKeyLength () const
| returns largest valid key length in bytes */
unsigned int | DefaultKeyLength () const
| returns default (recommended) key length in bytes */
unsigned int | GetValidKeyLength (unsigned int n) const
| returns the smallest valid key length in bytes that is >= min(n, GetMaxKeyLength())
TwoBases< MessageAuthenticationCode, VariableKeyLength< 32, 0, UINT_MAX > >::IV_Requirement | IVRequirement () const
| returns the minimal requirement for secure IVs
virtual byte * | CreateUpdateSpace (unsigned int &size)
| request space to write input into
virtual void | Final (byte *digest)
| compute hash for current message, then restart for a new message
virtual void | CalculateDigest (byte *digest, const byte *input, unsigned int length)
| use this if your input is in one piece and you don't want to call Update() and Final() separately
virtual bool | Verify (const byte *digest)
| verify that digest is a valid digest for the current message, then reinitialize the object
virtual bool | VerifyDigest (const byte *digest, const byte *input, unsigned int length)
| use this if your input is in one piece and you don't want to call Update() and Verify() separately
virtual void | CalculateTruncatedDigest (byte *digest, unsigned int digestSize, const byte *input, unsigned int length)
| truncated version of CalculateDigest()
virtual bool | TruncatedVerify (const byte *digest, unsigned int digestLength)
| truncated version of Verify()
virtual bool | VerifyTruncatedDigest (const byte *digest, unsigned int digestLength, const byte *input, unsigned int length)
| truncated version of VerifyDigest()
virtual Clonable * | Clone () const
| this is not implemented by most classes yet
virtual bool | IsValidKeyLength (unsigned int n) const
| returns whether n is a valid key length
void | SetKeyWithRounds (const byte *key, unsigned int length, int rounds)
| calls SetKey() with an NameValuePairs object that just specifies "Rounds"
void | SetKeyWithIV (const byte *key, unsigned int length, const byte *iv)
| calls SetKey() with an NameValuePairs object that just specifies "IV"
bool | IsResynchronizable () const
| returns whether this object can be resynchronized (i.e. supports initialization vectors)
bool | CanUseRandomIVs () const
| returns whether this object can use random IVs (in addition to ones returned by GetNextIV)
bool | CanUsePredictableIVs () const
| returns whether this object can use random but possibly predictable IVs (in addition to ones returned by GetNextIV)
bool | CanUseStructuredIVs () const
| returns whether this object can use structured IVs, for example a counter (in addition to ones returned by GetNextIV)
virtual unsigned int | IVSize () const
| returns size of IVs used by this object
virtual void | Resynchronize (const byte *IV)
| resynchronize with an IV
virtual void | GetNextIV (byte *IV)
| get a secure IV for the next message
## Static Public Member Functions
static std::string __cdecl | StaticAlgorithmName ()
static unsigned int __cdecl | StaticGetValidKeyLength (unsigned int n)
## Protected Member Functions
void | KeyHash ()
void | AssertValidKeyLength (unsigned int length)
void | AssertValidKeyLength (unsigned int length) const
void | ThrowIfInvalidTruncatedSize (unsigned int size) const
void | ThrowIfInvalidKeyLength (const Algorithm &algorithm, unsigned int length)
void | ThrowIfResynchronizable ()
void | ThrowIfInvalidIV (const byte *iv)
const byte * | GetIVAndThrowIfInvalid (const NameValuePairs &params)
## Protected Attributes
PanamaHash< B > | m_hash
bool | m_keyed
SecByteBlock | m_key

## Member Function Documentation

void HermeticHashFunctionMAC< PanamaHash< B > , PanamaHash< B > >::SetKey | ( | const byte * | key,
|  | unsigned int | length,
|  | const NameValuePairs & | params = `g_nullNameValuePairs`
| ) | `[inline, virtual, inherited]`

  | set or reset the key of this object Parameters:
  | params | is used to specify Rounds, BlockSize, etc
Implements SimpleKeyingInterface. Definition at line 49 of file panama.h. References SecBlock< T, A >::Assign(), HermeticHashFunctionMAC< T_Hash, T_Info >::m_key, and HermeticHashFunctionMAC< T_Hash, T_Info >::Restart(). Referenced by PanamaMAC< B >::PanamaMAC().

virtual void HashTransformation::Final | ( | byte * | digest | ) | `[inline, virtual, inherited]`

| compute hash for current message, then restart for a new message Precondition: size of digest == DigestSize(). Definition at line 532 of file cryptlib.h. Referenced by PSSR_MEM_Base::ComputeMessageRepresentative(), PKCS1v15_SignatureMessageEncodingMethod::ComputeMessageRepresentative(), EMSA5Pad< T >::ComputeMessageRepresentative(), PKCS5_PBKDF2_HMAC< T >::DeriveKey(), DefaultEncryptor::FirstPut(), PSSR_MEM_Base::RecoverMessageFromRepresentative(), HMAC_Base::TruncatedFinal(), ZlibCompressor::WritePoststreamTail(), and Gzip::WritePoststreamTail().

virtual bool HashTransformation::Verify | ( | const byte * | digest | ) | `[inline, virtual, inherited]`

| verify that digest is a valid digest for the current message, then reinitialize the object Default implementation is to call Final() and do a bitwise comparison between its output and digest. Definition at line 558 of file cryptlib.h. Referenced by HashVerificationFilter::LastPut(), Gunzip::ProcessPoststreamTail(), and PSSR_MEM_Base::RecoverMessageFromRepresentative().

bool SimpleKeyingInterface::IsResynchronizable | ( |  | ) | const`[inline, inherited]`

| returns whether this object can be resynchronized (i.e. supports initialization vectors) If this function returns true, and no IV is passed to SetKey() and CanUseStructuredIVs()==true, an IV of all 0's will be assumed. Definition at line 384 of file cryptlib.h. Referenced by SimpleKeyingInterface::ThrowIfInvalidIV(), SimpleKeyingInterface::ThrowIfResynchronizable(), and BlockOrientedCipherModeBase::UncheckedSetKey().

virtual void SimpleKeyingInterface::GetNextIV | ( | byte * | IV | ) | `[inline, virtual, inherited]`

| get a secure IV for the next message This method should be called after you finish encrypting one message and are ready to start the next one. After calling it, you must call SetKey() or Resynchronize() before using this object again. This method is not implemented on decryption objects. Reimplemented in CipherModeBase, CTR_ModePolicy, and XMACC_Base< T >. Definition at line 400 of file cryptlib.h.

The documentation for this class was generated from the following file:

- panama.h